# HG changeset patch
# Node ID fac8b3c1a1d1
# Parent  e0f4a672f85d
diff --git a/libpurple/accounts.h b/libpurple/accounts.h
--- a/libpurple/accounts.h
+++ b/libpurple/accounts.h
@@ -27,6 +27,7 @@
 #define PURPLE_ACCOUNTS_H
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "status.h"
 
 G_BEGIN_DECLS
@@ -91,7 +92,10 @@ void purple_accounts_uninit(void);
  * purple_accounts_schedule_save:
  *
  * Schedules saving of accounts
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_accounts_schedule_save(void);
 
 G_END_DECLS
diff --git a/libpurple/action.h b/libpurple/action.h
--- a/libpurple/action.h
+++ b/libpurple/action.h
@@ -29,9 +29,14 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_PROTOCOL_ACTION (purple_protocol_action_get_type())
+
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef struct _PurpleProtocolAction PurpleProtocolAction;
 
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleProtocolActionCallback)(PurpleProtocolAction *action);
 
 /**
@@ -41,6 +46,7 @@ typedef void (*PurpleProtocolActionCallb
  * place this is used is by protocols to tell the core the list of available
  * right-click actions for a buddy list row.
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef struct _PurpleActionMenu PurpleActionMenu;
 
 #include "connection.h"
@@ -80,7 +86,10 @@ G_BEGIN_DECLS
  * Creates a new PurpleActionMenu.
  *
  * Returns: (transfer full): The PurpleActionMenu.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleActionMenu *purple_action_menu_new(const gchar *label, GCallback callback, gpointer data, GList *children);
 
 /**
@@ -88,7 +97,10 @@ PurpleActionMenu *purple_action_menu_new
  * @act: The PurpleActionMenu to free.
  *
  * Frees a PurpleActionMenu
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_action_menu_free(PurpleActionMenu *act);
 
 /**
@@ -98,7 +110,10 @@ void purple_action_menu_free(PurpleActio
  * Returns the label of the PurpleActionMenu.
  *
  * Returns: The label string.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_action_menu_get_label(const PurpleActionMenu *act);
 
 /**
@@ -108,7 +123,10 @@ const gchar *purple_action_menu_get_labe
  * Returns the callback of the PurpleActionMenu.
  *
  * Returns: (transfer none): The callback function.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GCallback purple_action_menu_get_callback(const PurpleActionMenu *act);
 
 /**
@@ -118,7 +136,10 @@ GCallback purple_action_menu_get_callbac
  * Returns the data stored in the PurpleActionMenu.
  *
  * Returns: The data.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_action_menu_get_data(const PurpleActionMenu *act);
 
 /**
@@ -128,7 +149,10 @@ gpointer purple_action_menu_get_data(con
  * Returns the children of the PurpleActionMenu.
  *
  * Returns: (element-type PurpleActionMenu) (transfer none): The menu children.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList* purple_action_menu_get_children(const PurpleActionMenu *act);
 
 /**
@@ -137,7 +161,10 @@ GList* purple_action_menu_get_children(c
  * @label: The label for the menu action.
  *
  * Set the label to the PurpleActionMenu.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_action_menu_set_label(PurpleActionMenu *act, const gchar *label);
 
 /**
@@ -146,7 +173,10 @@ void purple_action_menu_set_label(Purple
  * @callback: (scope notified):  The callback.
  *
  * Set the callback that will be used by the PurpleActionMenu.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_action_menu_set_callback(PurpleActionMenu *act, GCallback callback);
 
 /**
@@ -155,7 +185,10 @@ void purple_action_menu_set_callback(Pur
  * @data:  The data used by this PurpleActionMenu
  *
  * Set the label to the PurpleActionMenu.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_action_menu_set_data(PurpleActionMenu *act, gpointer data);
 
 /**
@@ -164,7 +197,10 @@ void purple_action_menu_set_data(PurpleA
  * @children: (element-type PurpleActionMenu) (transfer full): The menu children
  *
  * Set the children of the PurpleActionMenu.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_action_menu_set_children(PurpleActionMenu *act, GList *children);
 
 /******************************************************************************
@@ -175,7 +211,10 @@ void purple_action_menu_set_children(Pur
  * purple_protocol_action_get_type:
  *
  * Returns: The #GType for the #PurpleProtocolAction boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_protocol_action_get_type(void);
 
 /**
@@ -188,7 +227,10 @@ GType purple_protocol_action_get_type(vo
  * a list in the get_actions function of the protocol.
  *
  * Returns: (transfer full): The new #PurpleProtocolAction.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocolAction *purple_protocol_action_new(const gchar *label, PurpleProtocolActionCallback callback);
 
 /**
@@ -198,7 +240,10 @@ PurpleProtocolAction *purple_protocol_ac
  * Creates a newly allocated copy of @action.
  *
  * Returns: (transfer full): A copy of @action.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocolAction *purple_protocol_action_copy(PurpleProtocolAction *action);
 
 /**
@@ -206,7 +251,10 @@ PurpleProtocolAction *purple_protocol_ac
  * @action: The PurpleProtocolAction to free.
  *
  * Frees a PurpleProtocolAction
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_protocol_action_free(PurpleProtocolAction *action);
 
 
diff --git a/libpurple/blistnode.h b/libpurple/blistnode.h
--- a/libpurple/blistnode.h
+++ b/libpurple/blistnode.h
@@ -155,7 +155,10 @@ PurpleBlistNode *purple_blist_node_get_s
  * Returns a node's settings
  *
  * Returns: (transfer none): The hash table with the node's settings.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GHashTable *purple_blist_node_get_settings(PurpleBlistNode *node);
 
 /**
@@ -166,7 +169,10 @@ GHashTable *purple_blist_node_get_settin
  * Checks whether a named setting exists for a node in the buddy list
  *
  * Returns: TRUE if a value exists, or FALSE if there is no setting
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_blist_node_has_setting(PurpleBlistNode *node, const char *key);
 
 /**
diff --git a/libpurple/buddy.h b/libpurple/buddy.h
--- a/libpurple/buddy.h
+++ b/libpurple/buddy.h
@@ -100,7 +100,10 @@ G_BEGIN_DECLS
  * purple_buddy_get_type:
  *
  * Returns: The #GType for the #PurpleBuddy object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_buddy_get_type(void);
 
 /**
@@ -174,7 +177,10 @@ PurpleAccount *purple_buddy_get_account(
  * @name:  The name.
  *
  * Sets a buddy's name
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_set_name(PurpleBuddy *buddy, const char *name);
 
 /**
@@ -242,7 +248,10 @@ PurplePresence *purple_buddy_get_presenc
  * Updates a buddy's status.
  *
  * This should only be called from within Purple.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_update_status(PurpleBuddy *buddy, PurpleStatus *old_status);
 
 /**
@@ -281,7 +290,10 @@ const char *purple_buddy_get_alias_only(
  * @alias:  The server alias to be set.
  *
  * Sets the server alias for a buddy.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_set_server_alias(PurpleBuddy *buddy, const char *alias);
 
 /**
@@ -325,7 +337,10 @@ const char *purple_buddy_get_alias(Purpl
  * @alias:  The local alias for the buddy
  *
  * Sets the local alias for the buddy.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_set_local_alias(PurpleBuddy *buddy, const char *alias);
 
 /**
diff --git a/libpurple/buddyicon.h b/libpurple/buddyicon.h
--- a/libpurple/buddyicon.h
+++ b/libpurple/buddyicon.h
@@ -103,7 +103,10 @@ G_BEGIN_DECLS
  * purple_buddy_icon_get_type:
  *
  * Returns: The #GType for the #PurpleBuddyIcon boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_buddy_icon_get_type(void);
 
 /**
@@ -493,7 +496,10 @@ void purple_buddy_icons_uninit(void);
  * purple_buddy_icon_spec_get_type:
  *
  * Returns: The #GType for the #PurpleBuddyIconSpec boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_buddy_icon_spec_get_type(void);
 
 /**
@@ -510,7 +516,10 @@ GType purple_buddy_icon_spec_get_type(vo
  * Creates a new #PurpleBuddyIconSpec instance.
  *
  * Returns:  A new buddy icon spec.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddyIconSpec *purple_buddy_icon_spec_new(char *format, int min_width,
 		int min_height, int max_width, int max_height, size_t max_filesize,
 		PurpleBuddyIconScaleFlags scale_rules);
@@ -535,7 +544,10 @@ void purple_buddy_icon_spec_free(PurpleB
  *                   constrained by the spec.
  *
  * Gets display size for a buddy icon
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_buddy_icon_spec_get_scaled_size(PurpleBuddyIconSpec *spec,
 		int *width, int *height);
 
diff --git a/libpurple/buddylist.h b/libpurple/buddylist.h
--- a/libpurple/buddylist.h
+++ b/libpurple/buddylist.h
@@ -55,7 +55,10 @@ typedef struct _PurpleBuddyList PurpleBu
  * Please note, prpls shouldn't save default group name depending on current
  * locale. So, this function is mostly for libpurple2 compatibility. And for
  * improperly written prpls.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *
 _purple_blist_get_localized_default_group_name(void);
 
@@ -169,7 +172,10 @@ G_BEGIN_DECLS
  * purple_buddy_list_get_type:
  *
  * Returns: The #GType for the #PurpleBuddyList object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleBuddyList, purple_buddy_list, PURPLE, BUDDY_LIST,
                          GObject)
 
@@ -244,7 +250,10 @@ void purple_blist_set_visible(gboolean s
  * Updates the buddies hash table when a buddy has been renamed. This only
  * updates the cache, the caller is responsible for the actual renaming of
  * the buddy after updating the cache.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_update_buddies_cache(PurpleBuddy *buddy, const char *new_name);
 
 /**
@@ -255,7 +264,10 @@ void purple_blist_update_buddies_cache(P
  * Updates the groups hash table when a group has been renamed. This only
  * updates the cache, the caller is responsible for the actual renaming of
  * the group after updating the cache.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_update_groups_cache(PurpleGroup *group, const char *new_name);
 
 /**
@@ -361,7 +373,10 @@ void purple_blist_remove_group(PurpleGro
  * Finds the buddy struct given a name and an account
  *
  * Returns: (transfer none): The buddy or %NULL if the buddy does not exist.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddy *purple_blist_find_buddy(PurpleAccount *account, const char *name);
 
 /**
@@ -374,7 +389,10 @@ PurpleBuddy *purple_blist_find_buddy(Pur
  *
  * Returns: (transfer none): The buddy or %NULL if the buddy does not exist in
  *          the group.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddy *purple_blist_find_buddy_in_group(PurpleAccount *account, const char *name,
 		PurpleGroup *group);
 
@@ -387,7 +405,10 @@ PurpleBuddy *purple_blist_find_buddy_in_
  *
  * Returns: (element-type PurpleBuddy) (transfer container): %NULL if the buddy
  *          doesn't exist, or a GSList of PurpleBuddy structs.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GSList *purple_blist_find_buddies(PurpleAccount *account, const char *name);
 
 /**
@@ -397,7 +418,10 @@ GSList *purple_blist_find_buddies(Purple
  * Finds a group by name
  *
  * Returns: (transfer none): The group or %NULL if the group does not exist.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleGroup *purple_blist_find_group(const char *name);
 
 /**
@@ -406,7 +430,10 @@ PurpleGroup *purple_blist_find_group(con
  * Finds or creates default group.
  *
  * Returns: (transfer none): The default group.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleGroup *purple_blist_get_default_group(void);
 
 /**
@@ -613,7 +640,10 @@ void purple_blist_init(void);
  * Loads the buddy list.
  *
  * You shouldn't call this. purple_core_init() will do it for you.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_blist_boot(void);
 
 /**
diff --git a/libpurple/chat.h b/libpurple/chat.h
--- a/libpurple/chat.h
+++ b/libpurple/chat.h
@@ -39,6 +39,7 @@ typedef struct _PurpleChatClass PurpleCh
 #include "blistnode.h"
 #include "group.h"
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 /**
  * PurpleChat:
@@ -65,7 +66,10 @@ G_BEGIN_DECLS
  * purple_chat_get_type:
  *
  * Returns: The #GType for the #PurpleChat object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_chat_get_type(void);
 
 /**
@@ -99,7 +103,10 @@ const char *purple_chat_get_name(PurpleC
  * Returns the name of the chat
  *
  * Returns:       The first component value.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_chat_get_name_only(PurpleChat *chat);
 
 /**
@@ -108,7 +115,10 @@ const char *purple_chat_get_name_only(Pu
  * @alias:  The alias
  *
  * Sets the alias for a blist chat.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_chat_set_alias(PurpleChat *chat, const char *alias);
 
 /**
diff --git a/libpurple/circularbuffer.h b/libpurple/circularbuffer.h
--- a/libpurple/circularbuffer.h
+++ b/libpurple/circularbuffer.h
@@ -27,6 +27,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CIRCULAR_BUFFER (purple_circular_buffer_get_type())
@@ -58,7 +60,10 @@ struct _PurpleCircularBufferClass {
  * actual buffer until data is appended to it.
  *
  * Returns: The new PurpleCircularBuffer.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleCircularBuffer *purple_circular_buffer_new(gsize growsize);
 
 /**
@@ -69,7 +74,10 @@ PurpleCircularBuffer *purple_circular_bu
  *
  * Append data to the PurpleCircularBuffer.  This will grow the internal
  * buffer to fit the added data, if needed.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_circular_buffer_append(PurpleCircularBuffer *buffer, gconstpointer src, gsize len);
 
 /**
@@ -84,7 +92,10 @@ void purple_circular_buffer_append(Purpl
  * more data is available to read.
  *
  * Returns: the number of bytes that can be read from the PurpleCircularBuffer
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gsize purple_circular_buffer_get_max_read(PurpleCircularBuffer *buffer);
 
 /**
@@ -96,7 +107,10 @@ gsize purple_circular_buffer_get_max_rea
  *
  * Returns: TRUE if we successfully marked the bytes as having been read, FALSE
  *         otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_circular_buffer_mark_read(PurpleCircularBuffer *buffer, gsize len);
 
 /**
@@ -106,7 +120,10 @@ gboolean purple_circular_buffer_mark_rea
  *
  * Increases the buffer size by a multiple of grow size, so that it can hold at
  * least 'len' bytes.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_circular_buffer_grow(PurpleCircularBuffer *buffer, gsize len);
 
 /**
@@ -117,7 +134,10 @@ void purple_circular_buffer_grow(PurpleC
  * needed.
  *
  * Returns: The grow size of the buffer.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gsize purple_circular_buffer_get_grow_size(PurpleCircularBuffer *buffer);
 
 /**
@@ -127,7 +147,10 @@ gsize purple_circular_buffer_get_grow_si
  * Returns the number of bytes of this buffer that contain unread data.
  *
  * Returns: The number of bytes that contain unread data.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gsize purple_circular_buffer_get_used(PurpleCircularBuffer *buffer);
 
 /**
@@ -140,7 +163,10 @@ gsize purple_circular_buffer_get_used(Pu
  * call purple_circular_buffer_mark_read() to mark the retrieved data as read.
  *
  * Returns: The output pointer for the buffer.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_circular_buffer_get_output(PurpleCircularBuffer *buffer);
 
 /**
@@ -148,7 +174,10 @@ const gchar *purple_circular_buffer_get_
  * @buffer: The PurpleCircularBuffer to reset.
  *
  * Resets the buffer input and output pointers to the start of the buffer.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_circular_buffer_reset(PurpleCircularBuffer *buffer);
 
 G_END_DECLS
diff --git a/libpurple/connection.h b/libpurple/connection.h
--- a/libpurple/connection.h
+++ b/libpurple/connection.h
@@ -34,6 +34,8 @@
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONNECTION  purple_connection_get_type()
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleConnection, purple_connection, PURPLE,
                          CONNECTION, GObject)
 
@@ -328,7 +330,10 @@ PurpleAccount *purple_connection_get_acc
  * Returns the protocol managing a connection.
  *
  * Returns: (transfer none): The protocol.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleProtocol *purple_connection_get_protocol(PurpleConnection *gc);
 
 /**
@@ -523,7 +528,10 @@ GList *purple_connections_get_all(void);
  * Checks if at least one account is online.
  *
  * Returns: %TRUE if at least one account is online.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_connections_is_online(void);
 
 /**************************************************************************/
@@ -534,7 +542,10 @@ gboolean purple_connections_is_online(vo
  * purple_connection_ui_ops_get_type:
  *
  * Returns: The #GType for the #PurpleConnectionUiOps boxed structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_connection_ui_ops_get_type(void);
 
 /**
diff --git a/libpurple/contact.h b/libpurple/contact.h
--- a/libpurple/contact.h
+++ b/libpurple/contact.h
@@ -39,6 +39,7 @@ typedef struct _PurpleMetaContactClass P
 #include "countingnode.h"
 #include "group.h"
 #include "purpleaccount.h"
+#include "purpleversion.h"
 
 /**
  * PurpleMetaContact:
@@ -72,7 +73,10 @@ G_BEGIN_DECLS
  * purple_meta_contact_get_type:
  *
  * Returns: The #GType for the #PurpleMetaContact object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_meta_contact_get_type(void);
 
 /**
@@ -81,7 +85,10 @@ GType purple_meta_contact_get_type(void)
  * Creates a new contact
  *
  * Returns:       A new contact struct
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleMetaContact *purple_meta_contact_new(void);
 
 /**
@@ -91,7 +98,10 @@ PurpleMetaContact *purple_meta_contact_n
  * Gets the PurpleGroup from a PurpleMetaContact
  *
  * Returns: (transfer none): The group.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleGroup *purple_meta_contact_get_group(const PurpleMetaContact *contact);
 
 /**
@@ -101,7 +111,10 @@ PurpleGroup *purple_meta_contact_get_gro
  * Returns the highest priority buddy for a given contact.
  *
  * Returns: (transfer none): The highest priority buddy.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleBuddy *purple_meta_contact_get_priority_buddy(PurpleMetaContact *contact);
 
 /**
@@ -110,7 +123,10 @@ PurpleBuddy *purple_meta_contact_get_pri
  * @alias:    The alias
  *
  * Sets the alias for a contact.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_meta_contact_set_alias(PurpleMetaContact *contact, const char *alias);
 
 /**
@@ -120,7 +136,10 @@ void purple_meta_contact_set_alias(Purpl
  * Gets the alias for a contact.
  *
  * Returns:  The alias, or NULL if it is not set.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_meta_contact_get_alias(PurpleMetaContact *contact);
 
 /**
@@ -131,7 +150,10 @@ const char *purple_meta_contact_get_alia
  * Determines whether an account owns any buddies in a given contact
  *
  * Returns: TRUE if there are any buddies from account in the contact, or FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_meta_contact_on_account(PurpleMetaContact *contact, PurpleAccount *account);
 
 /**
@@ -140,7 +162,10 @@ gboolean purple_meta_contact_on_account(
  *
  * Invalidates the priority buddy so that the next call to
  * purple_meta_contact_get_priority_buddy recomputes it.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_meta_contact_invalidate_priority_buddy(PurpleMetaContact *contact);
 
 /**
@@ -151,7 +176,10 @@ void purple_meta_contact_invalidate_prio
  * Merges two contacts
  *
  * All of the buddies from source will be moved to target
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_meta_contact_merge(PurpleMetaContact *source, PurpleBlistNode *node);
 
 
diff --git a/libpurple/conversations.h b/libpurple/conversations.h
--- a/libpurple/conversations.h
+++ b/libpurple/conversations.h
@@ -27,6 +27,7 @@
 #define PURPLE_CONVERSATIONS_H
 
 #include "purpleconversation.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -48,7 +49,10 @@ void purple_conversations_set_ui_ops(Pur
  * Gets the default conversation UI operations structure.
  *
  * Returns:  The UI conversation operations structure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationUiOps *purple_conversations_get_ui_ops(void);
 
 /**
diff --git a/libpurple/countingnode.h b/libpurple/countingnode.h
--- a/libpurple/countingnode.h
+++ b/libpurple/countingnode.h
@@ -39,6 +39,7 @@
 #define PURPLE_IS_COUNTING_NODE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass), PURPLE_TYPE_COUNTING_NODE))
 #define PURPLE_COUNTING_NODE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS((obj), PURPLE_TYPE_COUNTING_NODE, PurpleCountingNodeClass))
 
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef struct _PurpleCountingNode PurpleCountingNode;
 typedef struct _PurpleCountingNodeClass PurpleCountingNodeClass;
 
diff --git a/libpurple/eventloop.h b/libpurple/eventloop.h
--- a/libpurple/eventloop.h
+++ b/libpurple/eventloop.h
@@ -29,6 +29,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurpleInputCondition:
  * @PURPLE_INPUT_READ:  A read condition.
@@ -93,7 +95,10 @@ guint purple_input_add(int fd, PurpleInp
  * systems pipe() is used.
  *
  * Returns: 0 on success, -1 on error.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int
 purple_input_pipe(int pipefd[2]);
 
diff --git a/libpurple/group.h b/libpurple/group.h
--- a/libpurple/group.h
+++ b/libpurple/group.h
@@ -41,6 +41,7 @@ typedef struct _PurpleGroupClass PurpleG
 #include "blistnode.h"
 #include "buddyicon.h"
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "status.h"
 
 /**************************************************************************/
@@ -79,7 +80,10 @@ G_BEGIN_DECLS
  * purple_group_get_type:
  *
  * Returns: The #GType for the #PurpleGroup object.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_group_get_type(void);
 
 /**
@@ -123,7 +127,10 @@ gboolean purple_group_on_account(PurpleG
  * @name:  The name of the group.
  *
  * Sets the name of a group.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_group_set_name(PurpleGroup *group, const char *name);
 
 /**
diff --git a/libpurple/image-store.h b/libpurple/image-store.h
--- a/libpurple/image-store.h
+++ b/libpurple/image-store.h
@@ -39,6 +39,7 @@
  */
 
 #include "image.h"
+#include "purpleversion.h"
 
 /**
  * PURPLE_IMAGE_STORE_PROTOCOL:
@@ -62,7 +63,10 @@ G_BEGIN_DECLS
  * use #purple_image_store_add_weak.
  *
  * Returns: the unique identifier for the @image.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint
 purple_image_store_add(PurpleImage *image);
 
@@ -76,7 +80,10 @@ purple_image_store_add(PurpleImage *imag
  * If the @image is already in the store, it will return its current id.
  *
  * Returns: the unique identifier for the @image.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint
 purple_image_store_add_weak(PurpleImage *image);
 
@@ -93,7 +100,10 @@ purple_image_store_add_weak(PurpleImage 
  * management, implement it on your own.
  *
  * Returns: the unique identifier for the @image.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 guint
 purple_image_store_add_temporary(PurpleImage *image);
 
@@ -105,7 +115,10 @@ purple_image_store_add_temporary(PurpleI
  *
  * Returns: (transfer none): the image referenced by @id, or %NULL if it
  *          doesn't exists.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *
 purple_image_store_get(guint id);
 
@@ -121,7 +134,10 @@ purple_image_store_get(guint id);
  *
  * Returns: (transfer none): the image referenced by @uri, or %NULL if it
  *          doesn't point to any valid image.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *
 purple_image_store_get_from_uri(const gchar *uri);
 
@@ -134,7 +150,10 @@ purple_image_store_get_from_uri(const gc
  *
  * Returns: (transfer full): the URI for the @image. Should be #g_free'd when
  * you done using it.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gchar *
 purple_image_store_get_uri(PurpleImage *image);
 
@@ -142,7 +161,10 @@ purple_image_store_get_uri(PurpleImage *
  * _purple_image_store_init: (skip)
  *
  * Initializes the image store subsystem.
+ *
+ * Since: 3.0.0
  */
+G_GNUC_INTERNAL
 void
 _purple_image_store_init(void);
 
@@ -150,7 +172,10 @@ void
  * _purple_image_store_uninit: (skip)
  *
  * Uninitializes the image store subsystem.
+ *
+ * Since: 3.0.0
  */
+G_GNUC_INTERNAL
 void
 _purple_image_store_uninit(void);
 
diff --git a/libpurple/image.h b/libpurple/image.h
--- a/libpurple/image.h
+++ b/libpurple/image.h
@@ -28,6 +28,8 @@
 
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_IMAGE  purple_image_get_type()
 
 struct _PurpleImageClass {
@@ -52,8 +54,10 @@ G_BEGIN_DECLS
  * This class also provides certain file-related features, like: friendly
  * filenames (not necessarily real filename for displaying); remote images
  * (which data is not yet loaded) or guessing file format from its header.
+ *
+ * Since: 3.0.0
  */
-
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleImage, purple_image, PURPLE, IMAGE, GObject)
 
 /**
@@ -63,7 +67,10 @@ G_DECLARE_DERIVABLE_TYPE(PurpleImage, pu
  * Loads a raw image data as a new #PurpleImage object.
  *
  * Returns: the new #PurpleImage.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *purple_image_new_from_bytes(GBytes *bytes);
 
 /**
@@ -77,7 +84,10 @@ PurpleImage *purple_image_new_from_bytes
  * you access its data.
  *
  * Returns: the new #PurpleImage.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *purple_image_new_from_file(const gchar *path, GError **error);
 
 /**
@@ -91,7 +101,10 @@ PurpleImage *purple_image_new_from_file(
  * to g_memdup2() it first.
  *
  * Returns: the new #PurpleImage.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *purple_image_new_from_data(const guint8 *data, gsize length);
 
 /**
@@ -105,7 +118,10 @@ PurpleImage *purple_image_new_from_data(
  * to g_memdup2() it first.
  *
  * Returns: the new #PurpleImage.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleImage *purple_image_new_take_data(guint8 *data, gsize length);
 
 /**
@@ -116,7 +132,10 @@ PurpleImage *purple_image_new_take_data(
  * Saves an @image to the disk.
  *
  * Returns: %TRUE if succeeded, %FALSE otherwise.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_image_save(PurpleImage *image, const gchar *path);
 
 /**
@@ -126,7 +145,10 @@ gboolean purple_image_save(PurpleImage *
  * Returns a new reference to the #GBytes that contains the image data.
  *
  * Returns: (transfer full): A #GBytes containing the image data.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GBytes *purple_image_get_contents(PurpleImage *image);
 
 
@@ -138,7 +160,10 @@ GBytes *purple_image_get_contents(Purple
  * really backed by an existing file. In the other case it returns %NULL.
  *
  * Returns: the physical path of the @image, or %NULL.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_image_get_path(PurpleImage *image);
 
 /**
@@ -148,7 +173,10 @@ const gchar *purple_image_get_path(Purpl
  * Returns the size of @image's data.
  *
  * Returns: the size of data, or 0 in case of failure.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gsize purple_image_get_data_size(PurpleImage *image);
 
 /**
@@ -158,7 +186,10 @@ gsize purple_image_get_data_size(PurpleI
  * Returns the pointer to the buffer containing image data.
  *
  * Returns: (transfer none): the @image data.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gconstpointer purple_image_get_data(PurpleImage *image);
 
 /**
@@ -168,7 +199,10 @@ gconstpointer purple_image_get_data(Purp
  * Guesses the @image format based on its contents.
  *
  * Returns: (transfer none): the file extension suitable for @image format.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_image_get_extension(PurpleImage *image);
 
 /**
@@ -178,7 +212,10 @@ const gchar *purple_image_get_extension(
  * Guesses the @image mime-type based on its contents.
  *
  * Returns: (transfer none): the mime-type suitable for @image format.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_image_get_mimetype(PurpleImage *image);
 
 /**
@@ -190,7 +227,10 @@ const gchar *purple_image_get_mimetype(P
  * is SHA-1, because it may change in the future.
  *
  * Returns: (transfer none): the generated file name.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_image_generate_filename(PurpleImage *image);
 
 /**
@@ -204,7 +244,10 @@ const gchar *purple_image_generate_filen
  *
  * The provided @filename may either be a full path, or contain
  * filesystem-unfriendly characters, because it will be reformatted.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_image_set_friendly_filename(PurpleImage *image, const gchar *filename);
 
 /**
@@ -219,7 +262,10 @@ void purple_image_set_friendly_filename(
  * #purple_image_generate_filename.
  *
  * Returns: (transfer none): the friendly filename.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_image_get_friendly_filename(PurpleImage *image);
 
 G_END_DECLS
diff --git a/libpurple/media.h b/libpurple/media.h
--- a/libpurple/media.h
+++ b/libpurple/media.h
@@ -116,7 +116,10 @@ PurpleAccount *purple_media_get_account(
  * Gets the protocol data from the media session.
  *
  * Returns: The protocol data retrieved.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_media_get_protocol_data(PurpleMedia *media);
 
 /**
@@ -125,7 +128,10 @@ gpointer purple_media_get_protocol_data(
  * @protocol_data: The data to set on the media session.
  *
  * Sets the protocol data on the media session.
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_media_set_protocol_data(PurpleMedia *media, gpointer protocol_data);
 
 /**
diff --git a/libpurple/media/enum-types.h b/libpurple/media/enum-types.h
--- a/libpurple/media/enum-types.h
+++ b/libpurple/media/enum-types.h
@@ -28,6 +28,8 @@
 
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 /**
@@ -279,7 +281,10 @@ GType purple_media_session_type_get_type
  * Gets the type of the state enum
  *
  * Returns: The state enum's GType
+ *
+ * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GType purple_media_state_get_type(void);
 
 G_END_DECLS
